{% extends "layout.jinja2" %}

{% block locale %}en{% endblock %}
{% block title %}Résif WS TimeSeries{% endblock %}
{% block description %}Résif WS TimeSeries v1{% endblock %}
{% block sidebar_link_title %}TimeSeries{% endblock %}

{% block script %}
    <script src="{{ url_for('static', filename='timeseries.js') }}"></script>
{% endblock %}

{% block content %}
    <h1 class="clearfix">
        TimeSeries
        <span class="float-right">
            <a class="btn btn-outline-primary btn-sm" role="button" aria-disabled="false" href="{{ url_for('doc') }}local=fr">FR</a>
            <a class="btn btn-outline-primary btn-sm disabled" role="button" aria-disabled="true">EN</a>
        </span>
    </h1>

    <p>
        This service provides access to the timeseries data of the RESIF seismic network. Optional signal processing may be applied and data may be returned in several formats.
    </p>

    <h3>Restrictions</h3>
    <ul>

        <li>The time span may be up to 31 days.</li>
        <li>Only unrestricted data are available.</li>
    </ul>

    <h3>Available features</h3>
    <ul>
        <li>Remove mean or trend of the time series.</li>
        <li>Scaling by constant value.</li>
        <li>Differentiation and integration.</li>
        <li>Calculate the envelope of the time series.</li>
        <li>Decimation to lower sample rates.</li>
        <li>Deconvolution of instrument response (with unit conversion and prefiltering).</li>
        <li>Output formats: miniSEED, SAC binary, ASCII, PNG or JPEG Plot</li>
    </ul>

    <h2>URL Builder</h2>
    <form method="GET" target="_blank" id="form-url-builder" class="card" data-url="{{ request.scheme }}://{{ request.host + url_for("query") }}?">
        <div class="card-body accordion accordion-flush">
                <div class="accordion-item">
                    <h3 class="accordion-header" id="label-panel-source">
                        <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#panel-source" aria-expanded="true" aria-controls="panel-source">
                            Data source
                        </button>
                    </h3>
                    <div id="panel-source" class="accordion-collapse collapse show" aria-labelledby="label-panel-source">
                        <div class="accordion-body">
                            <div class="row">
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <span class="input-group-text" id="label-input-network">Network</span>
                                        <input name="network" type="text" class="form-control" placeholder="network" aria-label="Network" aria-describedby="label-input-network" onchange="generate_url();" required>
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <span class="input-group-text" id="label-input-station">Station</span>
                                        <input name="station" type="text" class="form-control" placeholder="station" aria-label="Station" aria-describedby="label-input-station" onchange="generate_url();" required>
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <span class="input-group-text" id="label-input-location">Location</span>
                                        <input name="location" type="text" class="form-control" placeholder="location" aria-label="Location" aria-describedby="label-input-location" onchange="generate_url();" required>
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <span class="input-group-text" id="label-input-channel">Channel</span>
                                        <input name="channel" type="text" class="form-control" placeholder="channel" aria-label="Channel" aria-describedby="label-input-channel" onchange="generate_url();" required>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="accordion-item">
                    <h3 class="accordion-header" id="label-panel-time">
                        <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#panel-time" aria-expanded="true" aria-controls="panel-time">
                            Time range
                        </button>
                    </h3>
                    <div id="panel-time" class="accordion-collapse collapse show" aria-labelledby="label-panel-time">
                        <div class="accordion-body">
                            <div class="row">
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <span class="input-group-text" id="label-input-start">Start</span>
                                        <input name="date_start" type="date" class="form-control" placeholder="YYYY-MM-DD" aria-label="Start date" aria-describedby="label-input-start" onchange="generate_url();" required>
                                        <input name="time_start" type="time" class="form-control" placeholder="HH:mm:ss" aria-label="Start time" step="1" onchange="generate_url();">
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <span class="input-group-text" id="label-input-start">End</span>
                                        <input name="date_end" type="date" class="form-control" placeholder="YYYY-MM-DD" aria-label="End date" aria-describedby="label-input-end" onchange="generate_url();" required>
                                        <input name="time_end" type="time" class="form-control" placeholder="HH:mm:ss" aria-label="End time" step="1" onchange="generate_url();">
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="accordion-item">
                    <h3 class="accordion-header" id="label-panel-output">
                        <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#panel-output" aria-expanded="true" aria-controls="panel-output">
                            Output format configuration
                        </button>
                    </h3>
                    <div id="panel-output" class="accordion-collapse collapse show" aria-labelledby="label-panel-output">
                        <div class="accordion-body">
                            <div class="input-group mb-3">
                                <span class="input-group-text" id="label-input-format">Format</span>
                                <select name="format" class="form-select" aria-label="Format" aria-describedby="label-input-format" onchange="generate_url();">
                                    <option value="ascii" selected>ASCII</option>
                                    <option value="mseed">MSEED</option>
                                    <option value="sac">SAC</option>
                                    <option value="slist">slist</option>
                                    <option value="tspair">tspair</option>
                                    <option value="plot">Plot (image PNG)</option>
                                </select>
                            </div>
                            <div class="input-group mb-3">
                                <div class="input-group-text">
                                    <input class="form-check-input mt-0" type="checkbox" onclick="toggle('nodata');" id="toggle-nodata" onchange="generate_url();" checked>
                                </div>
                                <span class="input-group-text" id="label-input-nodata">Return code in case of no data</span>
                                <input name="nodata" type="number" class="form-control" placeholder="204" aria-label="Nodata" onchange="generate_url();" value="404">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="accordion-item">
                    <h3 class="accordion-header" id="label-panel-filter">
                        <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#panel-filter" aria-expanded="false" aria-controls="panel-filter">
                            Signal processing options
                        </button>
                    </h3>
                    <div id="panel-filter" class="accordion-collapse collapse" aria-labelledby="label-panel-filter">
                        <div class="accordion-body">
                            <div class="alert alert-info" role="alert">
                              <i class="bi bi-arrows-move"></i> Move filters to sort them!
                            </div>

                            <div class="list-group" id="list-filters">

                                <div class="list-group-item" data-id="detrend">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('detrend');" id="toggle-detrend" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-detrend"><i class="bi bi-arrows-move"></i>&nbsp;Detrend</span>
                                        <select name="detrend" class="form-select" aria-label="detrend" aria-describedby="label-input-detrend" onchange="generate_url();" disabled>
                                            <option value="true">Yes</option>
                                            <option value="false" selected>No</option>
                                        </select>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="demean">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('demean');" id="toggle-demean" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-demean"><i class="bi bi-arrows-move"></i>&nbsp;Demean</span>
                                        <select name="demean" class="form-select" aria-label="demean" aria-describedby="label-input-demean" onchange="generate_url();" disabled>
                                            <option value="true">Yes</option>
                                            <option value="false" selected>No</option>
                                        </select>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="taper">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('taper', ['percentage', 'type']);" id="toggle-taper" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-taper"><i class="bi bi-arrows-move"></i>&nbsp;Taper</span>
                                        <input name="taper_percentage" type="number" class="form-control" placeholder="" aria-label="Taper" aria-describedby="label-input-taper" onchange="generate_url();" disabled>
                                        <select name="taper_type" class="form-select" aria-label="correct" aria-describedby="label-input-correct" onchange="generate_url();" disabled>
                                            <option value="hanning">hanning</option>
                                            <option value="hamming">hamming</option>
                                            <option value="cosine">cosine</option>
                                        </select>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="decimate">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('decimate');" id="toggle-decimate" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-decimate"><i class="bi bi-arrows-move"></i>&nbsp;Decimate</span>
                                        <input name="decimate" type="number" class="form-control" placeholder="" aria-label="Decimate" aria-describedby="label-input-decimate" onchange="generate_url();" disabled>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="correct">
                                    <div class="row">
                                        <div class="col">
                                            <div class="input-group">
                                                <div class="input-group-text">
                                                    <input class="form-check-input mt-0" type="checkbox" onclick="toggle('correct');" id="toggle-correct" onchange="generate_url();">
                                                </div>
                                                <span class="input-group-text" id="label-input-correct"><i class="bi bi-arrows-move"></i>&nbsp;Correct</span>
                                                <select name="correct" class="form-select" aria-label="correct" aria-describedby="label-input-correct" onchange="generate_url();" disabled>
                                                    <option value="true">Yes</option>
                                                    <option value="false" selected>No</option>
                                                </select>
                                            </div>
                                        </div>
                                        <div class="col">
                                            <div class="input-group mb-2">
                                                <div class="input-group-text">
                                                    <input class="form-check-input mt-0" type="checkbox" onclick="toggle('waterlevel');" id="toggle-waterlevel" onchange="generate_url();">
                                                </div>
                                                <span class="input-group-text" id="label-input-waterlevel">Waterlevel</span>
                                                <input name="waterlevel" type="number" class="form-control" placeholder="60" aria-label="Waterlevel" aria-describedby="label-input-waterlevel" onchange="generate_url();" disabled>
                                            </div>
                                            <div class="input-group mb-2">
                                                <div class="input-group-text">
                                                    <input class="form-check-input mt-0" type="checkbox" onclick="toggle('freqlimits', ['f1', 'f2', 'f3', 'f4']);" id="toggle-freqlimits" onchange="generate_url();">
                                                </div>
                                                <span class="input-group-text" id="label-input-freqlimits">Freqlimits</span>
                                                <input name="freqlimits_f1" type="number" class="form-control" placeholder="f1" aria-label="" aria-describedby="label-input-freqlimits" onchange="generate_url();" disabled>
                                                <input name="freqlimits_f2" type="number" class="form-control" placeholder="f2" aria-label="" aria-describedby="label-input-freqlimits" onchange="generate_url();" disabled>
                                                <input name="freqlimits_f3" type="number" class="form-control" placeholder="f3" aria-label="" aria-describedby="label-input-freqlimits" onchange="generate_url();" disabled>
                                                <input name="freqlimits_f4" type="number" class="form-control" placeholder="f4" aria-label="" aria-describedby="label-input-freqlimits" onchange="generate_url();" disabled>
                                            </div>
                                            <div class="input-group">
                                                <div class="input-group-text">
                                                    <input class="form-check-input mt-0" type="checkbox" onclick="toggle('units');" id="toggle-units" onchange="generate_url();">
                                                </div>
                                                <span class="input-group-text" id="label-input-units">Units</span>
                                                <select name="units" class="form-select" aria-label="units" aria-describedby="label-input-units" onchange="generate_url();" disabled>
                                                    <option value="AUTO" selected>AUTO</option>
                                                    <option value="DISP">DISP</option>
                                                    <option value="VEL">VEL</option>
                                                    <option value="ACC">ACC</option>
                                                </select>
                                            </div>
                                        </div>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="diff">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('diff');" id="toggle-diff" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-diff"><i class="bi bi-arrows-move"></i>&nbsp;Diff</span>
                                        <select name="diff" class="form-select" aria-label="diff" aria-describedby="label-input-diff" onchange="generate_url();" disabled>
                                            <option value="true" selected>Yes</option>
                                            <option value="false">No</option>
                                        </select>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="int">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('int');" id="toggle-int" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-int"><i class="bi bi-arrows-move"></i>&nbsp;Int</span>
                                        <select name="int" class="form-select" aria-label="int" aria-describedby="label-input-int" onchange="generate_url();" disabled>
                                            <option value="true">Yes</option>
                                            <option value="false" selected>No</option>
                                        </select>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="lpfilter">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('lpfilter');" id="toggle-lpfilter" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-lpfilter"><i class="bi bi-arrows-move"></i>&nbsp;Low-pass</span>
                                        <input name="lpfilter" type="number" class="form-control" placeholder="" aria-label="Lpfilter" aria-describedby="label-input-lpfilter" onchange="generate_url();" disabled>
                                        <span class="input-group-text">Hz</span>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="hpfilter">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('hpfilter');" id="toggle-hpfilter" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-hpfilter"><i class="bi bi-arrows-move"></i>&nbsp;High-pass</span>
                                        <input name="hpfilter" type="number" class="form-control" placeholder="" aria-label="Hpfilter" aria-describedby="label-input-hpfilter" onchange="generate_url();" disabled>
                                        <span class="input-group-text">Hz</span>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="bpfilter">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('bpfilter', ['min', 'max']);" id="toggle-bpfilter" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-bpfilter"><i class="bi bi-arrows-move"></i>&nbsp;Band-pass</span>
                                        <input name="bpfilter_min" type="number" class="form-control" placeholder="Min" aria-label="Min" aria-describedby="label-input-bpfilter" onchange="generate_url();" disabled>
                                        <input name="bpfilter_max" type="number" class="form-control" placeholder="Max" aria-label="Max" aria-describedby="label-input-bpfilter" onchange="generate_url();" disabled>
                                        <span class="input-group-text">Hz</span>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="zerophase">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('zerophase');" id="toggle-zerophase" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-zerophase"><i class="bi bi-arrows-move"></i>&nbsp;Zerophase</span>
                                        <select name="zerophase" class="form-select" aria-label="zerophase" aria-describedby="label-input-zerophase" onchange="generate_url();" disabled>
                                            <option value="true">Yes</option>
                                            <option value="false" selected>No</option>
                                        </select>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="envelope">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('envelope');" id="toggle-envelope" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-envelope"><i class="bi bi-arrows-move"></i>&nbsp;Envelope</span>
                                        <select name="envelope" class="form-select" aria-label="envelope" aria-describedby="label-input-envelope" onchange="generate_url();" disabled>
                                            <option value="true">Yes</option>
                                            <option value="false" selected>No</option>
                                        </select>
                                    </div>
                                 </div>

                                <div class="list-group-item" data-id="scale">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('scale');" id="toggle-scale" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-scale"><i class="bi bi-arrows-move"></i>&nbsp;Scale</span>
                                        <input name="scale" class="form-control" placeholder="" aria-label="Scale" aria-describedby="label-input-scale" onchange="generate_url();" disabled>
                                    </div>
                                </div>

                                <div class="list-group-item" data-id="divscale">
                                    <div class="input-group">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('divscale');" id="toggle-divscale" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-divscale"><i class="bi bi-arrows-move"></i>&nbsp;Divscale</span>
                                        <input name="divscale" type="number" class="form-control" placeholder="" aria-label="Divscale" aria-describedby="label-input-divscale" onchange="generate_url();" disabled>
                                    </div>
                                </div>
                            </div>

                        </div>
                    </div>
                </div>

                <div class="accordion-item">
                    <h3 class="accordion-header" id="label-panel-plot">
                        <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#panel-plot" aria-expanded="false" aria-controls="panel-plot">
                            Plot options
                        </button>
                    </h3>
                    <div id="panel-plot" class="accordion-collapse collapse" aria-labelledby="label-panel-plot">
                        <div class="accordion-body">

                            <div class="row">
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('showtitle');" id="toggle-showtitle" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-showtitle">Title</span>
                                        <select name="showtitle" class="form-select" aria-label="Showtitle" aria-describedby="label-input-showtitle" onchange="generate_url();" disabled>
                                            <option value="true" selected>Yes</option>
                                            <option value="false">No</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col">

                                    <div class="input-group mb-3">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('showscale');" id="toggle-showscale" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-showscale">Scale</span>
                                        <select name="showscale" class="form-select" aria-label="Showscale" aria-describedby="label-input-showscale" onchange="generate_url();" disabled>
                                            <option value="true" selected>Yes</option>
                                            <option value="false">No</option>
                                        </select>
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('monochrome');" id="toggle-monochrome" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-monochrome">Greyscale</span>
                                        <select name="monochrome" class="form-select" aria-label="Monochrome" aria-describedby="label-input-monochrome" onchange="generate_url();" disabled>
                                            <option value="true">Yes</option>
                                            <option value="false" selected>No</option>
                                        </select>
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('width');" id="toggle-width" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-width">Width</span>
                                        <input name="width" type="number" class="form-control" placeholder="1200" aria-label="Width" aria-describedby="label-input-width" onchange="generate_url();" disabled>
                                    </div>
                                </div>
                                <div class="col">
                                    <div class="input-group mb-3">
                                        <div class="input-group-text">
                                            <input class="form-check-input mt-0" type="checkbox" onclick="toggle('height');" id="toggle-height" onchange="generate_url();">
                                        </div>
                                        <span class="input-group-text" id="label-input-height">Height</span>
                                        <input name="height" type="number" class="form-control" placeholder="400" aria-label="Height" aria-describedby="label-input-height" onchange="generate_url();" disabled>
                                    </div>
                                </div>
                            </div>

                        </div>
                    </div>
                </div>

            </div>

        <div class="card-footer">
            <div class="input-group mb-3">
                <input type="text" class="form-control" placeholder="" aria-label="URL" id="input-generated-url" readonly>
                <div class="input-group-append">
                    <button id="button-copy" class="btn btn-secondary" type="button" data-clipboard-target="#input-generated-url">
                        <i class="bi bi-clipboard-plus"></i>
                    </button>
                    <button id="button-run" class="btn btn-primary" type="button" onclick="run_url();">
                        <i class="bi bi-play-fill"></i>
                    </button>
                </div>
            </div>
        </div>
    </form>

    <h2>Documentation</h2>

    <h3>Examples</h3>
    <ul>
        <li><a href="{{ url_for('query') }}?net=RA&station=PYTO&cha=HN2&loc=02&demean&correct&start=2017-11-02T13:35:00&end=2017-11-02T13:40:00&format=ascii">{{ request.host + url_for('query') }}?net=RA&amp;station=PYTO&amp;cha=HN2&amp;loc=02&amp;demean&amp;correct&amp;start=2017-11-02T13:35:00&amp;end=2017-11-02T13:40:00&amp;format=ascii</a></li>
        <li><a href="{{ url_for('query') }}?net=RA&station=PYTO&cha=HN2&loc=02&demean&correct&start=2017-11-02T13:35:00&end=2017-11-02T13:40:00&format=plot">{{ request.host + url_for('query') }}?net=RA&amp;station=PYTO&amp;cha=HN2&amp;loc=02&amp;demean&amp;correct&amp;start=2017-11-02T13:35:00&amp;end=2017-11-02T13:40:00&amp;format=plot</a></li>
    </ul>

    <h3>Usage</h3>
    <pre><code>/query? (channel-options) (date-range-options) (output-options) [filter-options] {plot-options} [nodata=404]

where :
channel-options      ::  (net=&lt;network&gt; sta=&lt;station&gt; loc=&lt;location&gt; cha=&lt;channel&gt;)
date-range-options   ::  (starttime=&lt;date&gt;) (endtime=&lt;date|duration&gt;)
output-options       ::  (format=&lt;ascii|mseed|sac|slist|tspair|plot&gt;)
plot-options         ::  {showtitle=&lt;TRUE|false&gt;} {showscale=&lt;TRUE|false&gt;} {monochrome=&lt;true|FALSE&gt;}
plot-options         ::  {width=&lt;400-2000&gt;} {height=&lt;200-2000&gt;}
filter-options       ::  [demean=&lt;TRUE|false&gt;] [detrend=&lt;true|FALSE&gt;]
filter-options       ::  [taper=&lt;0.0-0.5,HANNING|hamming|cosine&gt;]
filter-options       ::  [decimate=&lt;2-16&gt;]
filter-options       ::  [correct=&lt;true|FALSE&gt;] {waterlevel=&lt;number&gt;} {freqlimits=&lt;f1-f2-f3-f4&gt;} {units=&lt;AUTO|disp|vel|acc&gt;}
filter-options       ::  [diff=&lt;true|FALSE&gt;] [int=&lt;true|FALSE&gt;]
filter-options       ::  [lpfilter=&lt;frequency&gt;] [hpfilter=&lt;frequency&gt;] [bpfilter=&lt;fmin-fmax&gt;] {zerophase=&lt;true|FALSE&gt;}
filter-options       ::  [envelope=&lt;true|FALSE&gt;]
filter-options       ::  [scale=&lt;number&gt;] [divscale=&lt;number&gt;]

(..) mandatory
[..] optional
{..} optional, but complements another option
default values are uppercase</code></pre>

    <h3>Parameters</h3>

    <h4>Data source</h4>

    <table class="table table-striped">
        <thead>
            <tr>
                <th>Parameter</th>
                <th>Alias</th>
                <th>Description</th>
                <th>Example</th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td>network</td>
                <td>net</td>
                <td>Seismic network name. Accepts wildcards and lists.</td>
                <td>FR</td>
            </tr>
            <tr>
                <td>station</td>
                <td>sta</td>
                <td>Station name. Accepts wildcards and lists.</td>
                <td>CIEL</td>
            </tr>
            <tr>
                <td>location</td>
                <td>loc</td>
                <td>Location code. Use loc=-- for empty location codes. Accepts wildcards and lists.</td>
                <td>00</td>
            </tr>
            <tr>
                <td>channel</td>
                <td>cha</td>
                <td>Channel Code. Accepts wildcards and lists.</td>
                <td>HHZ</td>
            </tr>
        </tbody>
    </table>

    <h5>Wildcards and lists</h5>
    <ul>
        <li>Wildcards: the question mark <strong>?</strong> represents any single character, while the asterisk <strong>*</strong> represents zero or more characters.</li>
        <li>List: multiple items may be retrieved using a comma-separated list. Wildcards may be included in the list.</li>
    </ul>
    <p>For example, with channel codes: channel=EH?,BHZ</p>

    <h4>Date range options</h4>

    <table class="table table-striped">
        <thead>
            <tr>
                <th>Parameter</th>
                <th>Alias</th>
                <th>Description</th>
                <th>Example</th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td>starttime</td>
                <td>start</td>
                <td>Selects data on or after the specified start time.</td>
                <td>2010-01-10T00:00:00</td>
            </tr>
            <tr>
                <td>endtime</td>
                <td>end</td>
                <td>Selects data on or before the specified end time.</td>
                <td>2011-02-11T01:00:00</td>
            </tr>
        </tbody>
    </table>

    <p>The definition of the time interval may take different forms:</p>
    <ul>
        <li>a calendar dates, for example starttime=2015-08-12T01:00:00</li>
        <li>duration in seconds, for example endtime=7200</li>
        <li>the key word “currentutcday” which means midnight of today’s date (UTC time), for example starttime=currentutcday</li>
    </ul>

    <h5>Date and time formats</h5>
    <pre><code>YYYY-MM-DDThh:mm:ss[.ssssss] ex. 1997-01-31T12:04:32.123
YYYY-MM-DD ex. 1997-01-31 (a time of 00:00:00 is assumed)
currentutcday  (today at 00:00:00)

where:

YYYY    :: four-digit year
MM      :: two-digit month (01=January, etc.)
DD      :: two-digit day (01 through 31)
T       :: date-time separator
hh      :: two-digit hour (00 through 23)
mm      :: two-digit number of minutes (00 through 59)
ss      :: two-digit number of seconds (00 through 59)
ssssss  :: one to six-digit number of microseconds (0 through 999999)</code></pre>

    <h4>Output format configuration</h4>

    <table class="table table-striped">
        <thead>
            <tr>
                <th>Parameter</th>
                <th>Alias</th>
                <th>Default</th>
                <th>Description</th>
                <th>Example</th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td>format</td>
                <td></td>
                <td></td>
                <td>Format of the output file : ascii (equivalent to tspair), mseed, sac, slist or plot (graphical output).</td>
                <td>ascii</td>
            </tr>
            <tr>
                <td>nodata</td>
                <td></td>
                <td>204</td>
                <td>Return code in case of no data</td>
                <td>404</td>
            </tr>
        </tbody>
    </table>

    <h4>Time series processing options</h4>

    <p>The following parameters allow filtering the time series. Parameter order matters because each operation is performed in the order given.</p>

    <table class="table table-striped">
        <thead>
            <tr>
                <th>Parameter</th>
                <th>Alias</th>
                <th>Default</th>
                <th>Unit</th>
                <th>Description</th>
                <th>Example</th>
                <th>Documentation</th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td>demean</td>
                <td></td>
                <td>false</td>
                <td></td>
                <td>Remove the mean of the time series.</td>
                <td>true</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.detrend.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>detrend</td>
                <td></td>
                <td>false</td>
                <td></td>
                <td>Remove the trend of the time series.</td>
                <td>true</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.detrend.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>taper</td>
                <td></td>
                <td></td>
                <td></td>
                <td>Tapering in the time domain. The window width is specified as a fraction of the trace length from 0 to 0.5. The width may be optionally followed by window type : HANNING (défaut), HAMMING, COSINE.</td>
                <td>0.25<br/>0.25, HANNING<br/>0.35, COSINE</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.taper.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>decimate</td>
                <td>deci</td>
                <td></td>
                <td></td>
                <td>Decimation factor. A low-pass filter is applied prior to decimation (anti-aliasing filter).</td>
                <td>2.0</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.decimate.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>correct</td>
                <td></td>
                <td>false</td>
                <td></td>
                <td>Apply instrumental correction by deconvolution with earth unit’s conversion.</td>
                <td>true</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.remove_response.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>waterlevel</td>
                <td></td>
                <td>60</td>
                <td>dB</td>
                <td>Waterlevel used for the deconvolution. <br/> “Noe” value corresponds to the classical inverse filtering.</td>
                <td>1<br/>none</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.remove_response.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>freqlimits</td>
                <td></td>
                <td></td>
                <td></td>
                <td>Band pass filter applied to the frequency domain prior to the deconvolution<sup>1,2</sup>. Rectangular window between f2 and f3 and cosine window between f1 and f2 and between f3 and f4</td>
                <td>0.01-0.04-0.5-0.6</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.remove_response.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>units</td>
                <td></td>
                <td>AUTO</td>
                <td></td>
                <td>Output unit (AUTO, DISP, VEL, ACC). Enabled only with the correct option.</td>
                <td>VEL</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.remove_response.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>diff</td>
                <td></td>
                <td>false</td>
                <td></td>
                <td>Differentiate using centered method.</td>
                <td>true</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.differentiate.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>int</td>
                <td></td>
                <td>false</td>
                <td></td>
                <td>Integrate using trapezoidal method.</td>
                <td>true</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.integrate.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>lpfilter</td>
                <td>lp</td>
                <td></td>
                <td>Hz</td>
                <td>Low-pass filter with the specified cutoff <sup>1</sup>.</td>
                <td>1.0</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.signal.filter.lowpass.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>hpfilter</td>
                <td>hp</td>
                <td></td>
                <td>Hz</td>
                <td>High-pass filter with the specified cutoff <sup>1</sup>.</td>
                <td>2.0</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.signal.filter.highpass.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>bpfilter</td>
                <td>bp</td>
                <td></td>
                <td>Hz</td>
                <td>Band-pass filter with the specified range <sup>1,2,3</sup>.</td>
                <td>0.5-1.2</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.signal.filter.bandpass.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>zerophase</td>
                <td></td>
                <td>false</td>
                <td></td>
                <td>Zerophase filtering (may be used with lpfilter, hpfilter or bpfilter option).</td>
                <td>true</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.core.trace.Trace.filter.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>envelope</td>
                <td></td>
                <td>false</td>
                <td></td>
                <td>Time series envelope calculed with the approximated Hilbert transform.</td>
                <td>true</td>
                <td><a href="https://docs.obspy.org/packages/autogen/obspy.signal.filter.envelope.html" target="_blank">ObsPy</a></td>
            </tr>
            <tr>
                <td>scale</td>
                <td></td>
                <td></td>
                <td></td>
                <td>Scale data samples by the specified factor.</td>
                <td>1.5</td>
                <td></td>
            </tr>
            <tr>
                <td>divscale</td>
                <td></td>
                <td></td>
                <td></td>
                <td>Scale data samples by the inverse of the specified factor.</td>
                <td>4.0</td>
                <td></td>
            </tr>
        </tbody>
    </table>

    <p>Notes :</p>
    <ol>
        <li>Frequency in Hertz.</li>
        <li>IIR 4th order filter with a Butterworth window</li>
        <li>Frequency numbers may be separated by a comma or by a dash. For example : 0.01,0.02 or 0.01-0.02</li>
    </ol>

    <h4>Plot options</h4>

    <table class="table table-striped">
        <thead>
            <tr>
                <th>Parameter</th>
                <th>Alias</th>
                <th>Default</th>
                <th>Description</th>
                <th>Example</th>
            </tr>
        </thead>
        <tbody>
            <tr>
                <td>showtitle</td>
                <td></td>
                <td>true</td>
                <td>Whether or not to show the channel and date-range information on the top of the plot.</td>
                <td>false</td>
            </tr>
            <tr>
                <td>showscale</td>
                <td></td>
                <td>true</td>
                <td>Whether or not to show a scale on the right-side axis of the plot.</td>
                <td>false</td>
            </tr>
            <tr>
                <td>monochrome</td>
                <td></td>
                <td>false</td>
                <td>Creates a grayscale or a color plot.</td>
                <td>true</td>
            </tr>
            <tr>
                <td>width</td>
                <td></td>
                <td>1200</td>
                <td>Width of the output plot (pixels). The range is 400 to 2000.</td>
                <td>500</td>
            </tr>
            <tr>
                <td>height</td>
                <td></td>
                <td>400</td>
                <td>Height of the output plot(pixels). The range is 200 to 2000.</td>
                <td>400</td>
            </tr>
        </tbody>
    </table>

    <h3>Support</h3>
    <p>Sources are distributed under the terms of <a href="https://choosealicense.com/licenses/gpl-3.0">GPLv3 licence</a> and are available at <a href="https://gricad-gitlab.univ-grenoble-alpes.fr/OSUG/RESIF/ws-timeseries">https://gricad-gitlab.univ-grenoble-alpes.fr/OSUG/RESIF/ws-timeseries</a></p>
    <p>For questions about accessing data, filling bug reports, making suggestions, asking for help, please visit <a href="https://gitlab.com/resif/sismo-help">our helpdesk</a> or send an email to <a href="mailto:sismo-help@resif.fr">sismo-help@resif.fr</a></p>

{% endblock %}
